DIPlib Documentation - ©1995-2009 Quantitative Imaging Group, Delft University of Technology.

# MultiScaleMorphologicalGradient

Morphological edge detector

## SYNOPSIS

`#include "dip_morphology.h"`

dip_Error dip_MultiScaleMorphologicalGradient ( in, out, se, boundary, upperSize, lowerSize, shape )

## DATA TYPES

integer, float

## FUNCTION

This function computes the average morphological gradient over a range of scales bounded by `upperSize` and `lowerSize`. The morphological gradient is computed as the difference of the dilation and erosion of the input image at a particular scale, eroded by an erosion of one size smaller. At the lowest scale, the size of the structuring element is `2 * upperSize + 1`.

The rectangular, elliptic and diamond structuring elements are "flat", i.e. these structuring elements have a constant value. For these structuring elements, `filterParam` determines the sizes of the structuring elements. When `shape` is set to `DIP_FLT_SHAPE_PARABOLIC`, `filterParams` specifies the curvature of the parabola. When `shape` is set to `DIP_FLT_SHAPE_STRUCTURING_ELEMENT`, `se` is used as structuring element. It can be either a binary or a grey-value image, but be careful: it is converted to the same data type as the input image, and might therefore be clipped or loose precision. It is required (in the current implementation) that the structuring element be odd in size. Its origin is the center.

If `shape` is not equal to `DIP_FLT_SHAPE_STRUCTURING_ELEMENT`, `se` is allowed to be set to zero. When `shape` is set to `DIP_FLT_SHAPE_STRUCTURING_ELEMENT`, `filterParam` is ignored, (and can be set to zero).

## ARGUMENTS

Data type | Name | Description
`dip_Image` | `in` | Input
`dip_Image` | `out` | Output
`dip_Image` | `se` | Structuring element
`dip_BoundaryArray` | `boundary` | Boundary conditions
`dip_int` | `upperSize` | Upper size of structuring element
`dip_int` | `lowerSize` | Lower size of structuring element
`dip_FilterShape` | `shape` | Filter shape

The enumerator `dip_FilterShape` contains the following constants:

Name | Description
`DIP_FLT_SHAPE_DEFAULT` | default structuring element, same as `DIP_FLT_SHAPE_RECTANGULAR`
`DIP_FLT_SHAPE_RECTANGULAR` | rectangular structuring element
`DIP_FLT_SHAPE_ELLIPTIC` | elliptic structuring element
`DIP_FLT_SHAPE_DIAMOND` | diamond shaped structuring element
`DIP_FLT_SHAPE_PARABOLIC` | parabolic structuring element
`DIP_FLT_SHAPE_STRUCTURING_ELEMENT` | use `se` as structuring element

## LITERATURE

D. Wang, Pattern Recognition, 30(12), pp. 2043-2052, 1997

## SEE ALSO

`Lee`, `MorphologicalGradientMagnitude`, `MorphologicalRange`, `Tophat`

DIPlib on-line documentation | Function reference | Global function index